<!DOCTYPE html>
<html <?php language_attributes(); ?>>
<head>
<meta charset="<?php bloginfo( 'charset' ); ?>" />
<title><?php
	/*
	 * Print the <title> tag based on what is being viewed.
	 */
	global $page, $paged;

	wp_title( '|', true, 'right' );

	// Add the blog name.
	bloginfo( 'name' );

	// Add a page number if necessary:
	if ( $paged >= 2 || $page >= 2 )
		echo ' | ' . sprintf( __( 'Page %s', 'twentyten' ), max( $paged, $page ) );

	?></title>
<link rel="profile" href="http://gmpg.org/xfn/11" />
<link rel="stylesheet" type="text/css" media="all" href="<?php bloginfo( 'stylesheet_url' ); ?>" />
<link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>" />
<?php
	/* We add some JavaScript to pages with the comment form
	 * to support sites with threaded comments (when in use).
	 */
	if ( is_singular() && get_option( 'thread_comments' ) )
		wp_enqueue_script( 'comment-reply' );

	/* Always have wp_head() just before the closing </head>
	 * tag of your theme, or you will break many plugins, which
	 * generally use this hook to add elements to <head> such
	 * as styles, scripts, and meta tags.
	 */
	wp_head();
?>
</head>

 <?php $body_classes = join( ' ', get_body_class( $class ) ); ?>
<!--[if gte IE 8]><body class="isIE <?php echo $body_classes; ?>"><![endif]-->
<!--[if IE 7]><body class="isIE7 <?php echo $body_classes; ?>"><![endif]-->
<!--[if IE 6]><body class="isIE6 <?php echo $body_classes; ?>"><![endif]-->
<!--[if !IE]>--><body class="notIE <?php echo $body_classes; ?>"><!--<![endif]-->
<div id="page" class="hfeed">
    <div id="header">
        <div id="branding" role="banner">
            <a id="site-title" href="<?php echo home_url('/'); ?>" title="<?php echo esc_attr(get_bloginfo('name', 'display')); ?>" rel="home"><img alt="Logo" src="<?php bloginfo('template_url'); ?>/images/logo.png" /></a>
        </div><!-- #branding -->
	<?php /* Our navigation menu.  If one isn't filled out, wp_nav_menu falls back to wp_page_menu.  The menu assiged to the primary position is the one used.  If none is assigned, the menu with the lowest ID is used.  */ ?>
        <ul id="main_menu">
            <?php
               custom_wp_list_pages('title_li=');
            ?>
        </ul>
    </div><!-- #header -->

    <div id="main">
